unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Controls, Forms, FileCtrl,
  StdCtrls, XPMan, ImgList, ComCtrls, Buttons, Grids, ValEdit, ExtCtrls,
  ShellCtrls, Menus, Dialogs, IniFiles, CommCtrl, Graphics, LstFile, OleCtrls;

type
  PNodeOptions = ^NodeOptions;
  NodeOptions = record
   Path: string[255];
   ExtFlag: string[255];
  end;
  TForm1 = class(TForm)
    ImageList1: TImageList;
    XPManifest1: TXPManifest;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    ValueListEditor1: TValueListEditor;
    CheckBox1: TCheckBox;
    Panel1: TPanel;
    Splitter1: TSplitter;
    Panel2: TPanel;
    ShellTreeView1: TShellTreeView;
    Panel3: TPanel;
    Splitter2: TSplitter;
    TreeView1: TTreeView;
    ShellListView1: TShellListView;
    TabSheet5: TTabSheet;
    PopupMenu1: TPopupMenu;
    De1: TMenuItem;
    AddFolder1: TMenuItem;
    N1: TMenuItem;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    OpenProject1: TMenuItem;
    SaveProject1: TMenuItem;
    SaveProjectAs1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    Bevel1: TBevel;
    NewProject1: TMenuItem;
    N3: TMenuItem;
    Label1: TLabel;
    Edit2: TEdit;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Edit3: TEdit;
    Edit4: TEdit;
    ComboBox1: TComboBox;
    Image1: TImage;
    Edit5: TEdit;
    Edit6: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    GroupBox3: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    Button4: TButton;
    ProgressBar1: TProgressBar;
    ProgressBar2: TProgressBar;
    Label2: TLabel;
    Label5: TLabel;
    Label9: TLabel;
    CheckBox2: TCheckBox;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Edit7: TEdit;
    Label10: TLabel;
    Label11: TLabel;
    Memo1: TMemo;
    Memo2: TMemo;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    ValueListEditor2: TValueListEditor;
    procedure ShellTreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure TreeView1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure TreeView1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure TreeView1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    function isInTree(path: string): boolean;
    procedure GetDirectories(Tree: TTreeView; Directory: string;Item: TTreeNode; IncludeFiles: Boolean);
    procedure AddFolder1Click(Sender: TObject);
    procedure De1Click(Sender: TObject);
    procedure ValueListEditor1DblClick(Sender: TObject);
    procedure SaveProjectAs1Click(Sender: TObject);
    procedure OpenProject1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure SaveProject(PrjPath: String);
    procedure SaveProject1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure NewProject1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ValueListEditor2DblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses datfile, Misc, Gauges, ImgBtn, WThread, Unit2;


{$R *.dfm}

var
  CurrentPrjName,Path, SknPath : String;
  Files: TStrings;

procedure LoadSki(path: string);
var
 m: TMemoryStream;
begin
    m:=TMemoryStream.Create;
    Load(path,'preview.bmp',m);
    Form1.image1.Picture.Bitmap.LoadFromStream(m);
    m.Clear;
    Load(path,'comment',m);
    Form1.Memo2.Lines.LoadFromStream(m);
    m.Free;
end;


procedure LoadBtnParam(list: TListFile; Btn: TImgBtn; btnname, path: string);
var
 m: TMemoryStream;
 pic: TPicture;
 tmpBool : boolean;
 tmpStr : string;
begin
 tmpStr:=list.GetKeyValueFromList('buttons','btn_'+btnname+'_visible');
 if tmpStr<>'' then tmpBool:=StrToBool(tmpStr)
 else tmpBool:=true;
 Btn.Visible:= tmpBool;
 if not tmpBool then exit;
 m:=TMemoryStream.Create;
 pic:=TPicture.Create;
 Load(path,btnname+'_normal.bmp',m);
 pic.Bitmap.LoadFromStream(m);
 Btn.Pic.Bitmap.LoadFromStream(m);
 Btn.SetPic(pic);
 pic.Free;
 m.Clear;
 Load(path,btnname+'_hover.bmp',m);
 Btn.PicUp.Bitmap.LoadFromStream(m);
 m.Clear;
 Load(path,btnname+'_pressed.bmp',m);
 Btn.PicDown.Bitmap.LoadFromStream(m);
 m.Clear;
 m.Free;
 Btn.Top:= StrToInt(list.GetKeyValueFromList('buttons','btn_'+btnname+'_top'));
 Btn.Left:= StrToInt(list.GetKeyValueFromList('buttons','btn_'+btnname+'_left'));
 Btn.Width:= StrToInt(list.GetKeyValueFromList('buttons','btn_'+btnname+'_width'));
 Btn.Height:= StrToInt(list.GetKeyValueFromList('buttons','btn_'+btnname+'_height'));
end;

procedure LoadProgressParam(list: TListFile; Pr: TGauge; name: string);
begin
  Pr.Top:=StrToInt(list.GetKeyValueFromList('progress',name+'_top'));
  Pr.Left:=StrToInt(list.GetKeyValueFromList('progress',name+'_left'));
  Pr.Width:=StrToInt(list.GetKeyValueFromList('progress',name+'_width'));
  Pr.Height:=StrToInt(list.GetKeyValueFromList('progress',name+'_height'));
  Pr.BackColor:=StringToColor(list.GetKeyValueFromList('progress',name+'_bg'));
  Pr.ForeColor:=StringToColor(list.GetKeyValueFromList('progress',name+'_fg'));
end;

procedure LoadLabelParam(list: TListFile; Lb: TLabel; name: string);
begin
  Lb.Top:=StrToInt(list.GetKeyValueFromList('labels',name+'_top'));
  Lb.Left:=StrToInt(list.GetKeyValueFromList('labels',name+'_left'));
  Lb.Caption:= list.GetKeyValueFromList('labels',name+'_text');
  Lb.Font.Color:=StringToColor(list.GetKeyValueFromList('labels',name+'_font_color'));
  Lb.Visible:=StrToBool(list.GetKeyValueFromList('labels',name+'_visible'));
end;



procedure LoadSkin(path: string);
var
 m: TMemoryStream;
 list: TListFile;
begin
    m:=TMemoryStream.Create;
    load(path,'skinparam',m);
    list:=TListFile.CreateFromStream(m);
    m.Clear;
    Form2.ClientWidth:=StrToInt(list.GetKeyValueFromList('main_frm','frm_width'));
    Form2.ClientHeight:=StrToInt(list.GetKeyValueFromList('main_frm','frm_height'));
    load(path,'fr_back.bmp',m);
    Form2.Image1.Picture.Bitmap.LoadFromStream(m);
    m.Clear;
    LoadBtnParam(list ,Form2.ImgBtn1,'cl',path);
    LoadBtnParam(list ,Form2.ImgBtn2,'se',path);
    LoadBtnParam(list ,Form2.ImgBtn3,'st',path);
    LoadBtnParam(list ,Form2.ImgBtn4,'ca',path);
    LoadBtnParam(list ,Form2.ImgBtn5,'fu',path);
    LoadProgressParam(list, Form2.Gauge1, 'file_progress');
    LoadProgressParam(list, Form2.Gauge2, 'total_progress');
    m.Free;
    Form2.Panel1.Top:=StrToInt(list.GetKeyValueFromList('browser','br_top'));
    Form2.Panel1.Left:=StrToInt(list.GetKeyValueFromList('browser','br_left'));
    Form2.Panel1.Height:=StrToInt(list.GetKeyValueFromList('browser','br_height'));
    Form2.Panel1.Width:=StrToInt(list.GetKeyValueFromList('browser','br_width'));
    LoadLabelParam(list, Form2.Label1, 'label1');
    LoadLabelParam(list, Form2.Label2, 'label2');
    LoadLabelParam(list, Form2.Label3, 'label3');
    list.Free;
    form2.Visible:=true;
end;

procedure GetRelativePath(Node: TTreeNode );
begin
 if PNodeOptions(Node.Data).Path<>'root' then
 begin
   if Path<>'' then Path:= Node.Text+'\'+Path
   else Path:=Node.Text;
   GetRelativePath(Node.Parent);
 end;
end;

procedure GetDirFiles(Dir: string);
var
  SearchRec: TSearchRec;
begin
  if Dir <> '' then
   if FindFirst(Dir + '*.skn', faAnyFile, SearchRec) = 0 then
    repeat
      Application.ProcessMessages;
      if (SearchRec.name = '.') or (SearchRec.name = '..') then
        continue;
      if (SearchRec.Attr and faDirectory) = 0 then
        begin
         Files.Add(SearchRec.Name);
        end
    until
      FindNext(SearchRec) <> 0;
  FindClose(SearchRec);
end;

procedure TForm1.SaveProject(PrjPath: String);
var
  plist: TStringList;
  i: integer;
  prjini: Tinifile;
  dir: string;
begin
   dir:=ExtractFilePath(PrjPath);
   TreeView1.SaveToFile(dir+'tree.dat');
   plist:=TStringList.Create;
   for i:=0 to TreeView1.Items.Count-1 do
   begin
      plist.Add(PNodeOptions(TreeView1.Items[i].Data).Path+'|'+PNodeOptions(TreeView1.Items[i].Data).ExtFlag);
   end;
   plist.SaveToFile(dir+'path.dat');
   plist.Clear;
   ValueListEditor1.Strings.SaveToFile(dir+'hosts.dat');
   ValueListEditor2.Strings.SaveToFile(dir+'_mirrors.dat');
   prjini:=TInifile.Create(PrjPath);
   prjini.WriteString('main','custom_name', Edit2.Text);
   prjini.WriteString('main','revision', IntToStr(Round((Date() - 25569.0) * 86400)));
   prjini.WriteString('main','news_url', Edit3.Text);
   if trim(edit4.Text)<>'' then begin
     prjini.WriteString('main','create_st', 'true');
     prjini.WriteString('main','st_name', Edit4.Text);
   end;
   prjini.WriteString('main','skn_name', ComboBox1.Text);
   prjini.WriteString('main','app_path', Edit7.Text);
   prjini.WriteString('build','client_out', Edit5.Text);
   prjini.WriteString('build','updates_out', Edit6.Text);
   prjini.Free;
   plist.Add(dir+'hosts.dat');
   plist.Add(dir+'mirrors.dat');
   plist.Add(dir+'path.dat');
   plist.Add(dir+'tree.dat');
   PrjPath:=ChangeFileExt(PrjPath,'.dat');
   Save(PrjPath,plist,true);
   plist.Free;
   CurrentPrjName:= PrjPath;
end;

procedure TForm1.GetDirectories(Tree: TTreeView; Directory: string;
Item: TTreeNode; IncludeFiles: Boolean);
var
  SearchRec: TSearchRec;
  ItemTemp: TTreeNode;
  NodeData: PNodeOptions;
begin
  Tree.Items.BeginUpdate;
  if Directory[Length(Directory)] <> '\' then Directory := Directory + '\';
  if FindFirst(Directory + '*.*', faDirectory, SearchRec) = 0 then
  begin
    repeat
      if (SearchRec.Attr and faDirectory = faDirectory) and
      (SearchRec.Name[1] <> '.') then
      begin
        if (SearchRec.Attr and faDirectory > 0) then
        begin
          Item := Tree.Items.AddChild(Item, SearchRec.Name);
          NodeData:= new (PNodeOptions);
          NodeData.Path:=Directory + SearchRec.Name;
          NodeData.ExtFlag:='folder';
          Item.Data:=NodeData;
        end;
        ItemTemp := Item.Parent;
        GetDirectories(Tree, Directory + SearchRec.Name, Item, IncludeFiles);
        Item := ItemTemp;
      end
      else if IncludeFiles then
        if SearchRec.Name[1] <> '.' then
        begin
          ItemTemp := Tree.Items.AddChild(Item, SearchRec.Name);
          NodeData:= new (PNodeOptions);
          NodeData.Path:=Directory + SearchRec.Name;
          NodeData.ExtFlag:='file';
          ItemTemp.Data:=NodeData;
        end;
    until FindNext(SearchRec) <> 0;
    FindClose(SearchRec);
  end;
  Tree.Items.EndUpdate;
end;

function TForm1.isInTree(path: string): boolean;
var
 i:integer;
begin
  result:=false;
  for i:=2 to TreeView1.Items.Count-1 do
  begin
  Application.ProcessMessages;
    if PNodeOptions(TreeView1.Items[i].Data).Path = path then
     begin
      result:=true;
      break;
     end;
  end;
end;

procedure TForm1.ShellTreeView1Change(Sender: TObject; Node: TTreeNode);
begin
 try
  ShellListView1.Root:=ShellTreeView1.Path;
 except
  ShellListView1.Clear;
 end;
end;

procedure TForm1.TreeView1DragDrop(Sender, Source: TObject; X, Y: Integer);
var
  i: integer;
  NewNode: TTreeNode;
  NodeData: PNodeOptions;
begin
  if (TreeView1.DropTarget.Index<0) or (PNodeOptions(TreeView1.DropTarget.Data).ExtFlag='file') then exit;
  if (Source = ShellTreeView1) then
  begin
  if isInTree(ShellTreeView1.Path) then exit;
     NewNode:=TreeView1.Items.AddChild(TreeView1.DropTarget, ShellTreeView1.Selected.Text);
     NodeData:= new (PNodeOptions);
     NodeData.Path:=ShellTreeView1.Path;
     NodeData.ExtFlag:='folder';
     NewNode.Data:=NodeData;
     GetDirectories(TreeView1,ShellTreeView1.Path,NewNode,true);
  end;
  TreeView1.Items.BeginUpdate;
  if (Source = ShellListView1)  then
  begin
    for i := 0 to ShellListView1.Items.Count -1 do
    begin
      if ShellListView1.Items[i].Selected then
      begin
       if not isInTree(ShellListView1.Folders[i].PathName) then
       begin
        NewNode:=TreeView1.Items.AddChild(TreeView1.DropTarget,ShellListView1.Folders[i].DisplayName);
        NodeData:= new (PNodeOptions);
        NodeData.Path:=ShellListView1.Folders[i].PathName;
        NodeData.ExtFlag:='file';
        NewNode.Data:=NodeData;
       end;
      end;
    end;
  end;
  TreeView1.Items.EndUpdate;
end;

procedure TForm1.TreeView1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  if (Source = ShellListView1) or (Source = ShellTreeView1) then
    Accept:= True;
end;

procedure TForm1.TreeView1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if GetKeyState(VK_DELETE) and 128 <> 0 then
 begin
  if (PNodeOptions(TreeView1.Selected.Data).ExtFlag<>'root_main') and
  (PNodeOptions(TreeView1.Selected.Data).ExtFlag<>'root_crit')  then
   begin
    TreeView1.Items.Delete(TreeView1.Selected);
   end;
 end;
end;




procedure TForm1.Exit1Click(Sender: TObject);
begin
 Close();
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  NodeData: PNodeOptions;
  m: TMemoryStream;
begin
    CurrentPrjName:='';
    SknPath:=ExtractFilePath(Application.ExeName)+'skn\';
    Files:=TStringList.Create;
    GetDirFiles(SknPath);
    ComboBox1.Items:=Files;
    ComboBox1.ItemIndex:=0;
    m:=TMemoryStream.Create;
    if(ComboBox1.Text<>'') then
    If (FileExists(SknPath+ChangeFileExt(ComboBox1.Text,'.l3i'))) then
     begin
      LoadSki(SknPath+ChangeFileExt(ComboBox1.Text,'.l3i'));
     end;
    m.Free;
    Files.Free;
    NodeData:= new (PNodeOptions);
    NodeData.ExtFlag:='root_main';
    NodeData.Path:='root';
    TreeView1.Items[0].Data:=NodeData;
    NodeData:= new (PNodeOptions);
    NodeData.ExtFlag:='root_crit';
    NodeData.Path:='root';
    TreeView1.Items[1].Data:=NodeData;
    if fileExists(ExtractFilePath(Application.ExeName)+'release.nfo') then
       Memo1.Lines.LoadFromFile(ExtractFilePath(Application.ExeName)+'release.nfo');
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
 if CheckBox1.Checked then
  ValueListEditor1.Enabled:=True
 else
  ValueListEditor1.Enabled:=False;
end;



procedure TForm1.AddFolder1Click(Sender: TObject);
var
 str: string;
 NewNode: TTreeNode;
 NodeData: PNodeOptions;
begin
  if (TreeView1.Selected = nil) or (PNodeOptions(TreeView1.Selected.Data).ExtFlag='file') then exit;
  InputQuery('Add Folder', 'Input Folder Name', str);
  if Trim(str) = '' then exit;
  NewNode:=TreeView1.Items.AddChild(TreeView1.Selected, str);
  NodeData:= new (PNodeOptions);
  NodeData.Path:='none';
  NodeData.ExtFlag:='folder';
  NewNode.Data:=NodeData;
end;

procedure TForm1.De1Click(Sender: TObject);
begin
  if TreeView1.Selected = nil then exit;
  if (PNodeOptions(TreeView1.Selected.Data).ExtFlag<>'root_main') and
  (PNodeOptions(TreeView1.Selected.Data).ExtFlag<>'root_crit')  then
    TreeView1.Items.Delete(TreeView1.Selected);
end;

procedure TForm1.ValueListEditor1DblClick(Sender: TObject);
begin
   ValueListEditor1.InsertRow('','',false);
end;

procedure TForm1.SaveProjectAs1Click(Sender: TObject);
begin
   SaveDialog1.Execute;
   if (SaveDialog1.FileName<>'') then
     SaveProject(SaveDialog1.FileName);
end;

procedure TForm1.OpenProject1Click(Sender: TObject);
var
  m: TMemoryStream;
  i: longint;
  p,z: TStringList;
  NodeData: PNodeOptions;
  dat_name: string;
  prjini: TIniFile;
begin
  OpenDialog1.Execute;
  if (OpenDialog1.FileName='') then exit;
  p:=TStringList.Create;
  z:=TStringList.Create;
  dat_name:= ChangeFileExt(OpenDialog1.FileName,'.dat');
  CurrentPrjName:=OpenDialog1.FileName;
  m:=TMemoryStream.Create;
  LoadUc(dat_name,'hosts.dat',m);
  ValueListEditor1.Strings.LoadFromStream(m);
  m.Clear;
  LoadUc(dat_name,'tree.dat',m);
  TreeView1.LoadFromStream(m);
  m.Clear;
  LoadUc(dat_name,'mirrors.dat',m);
  ValueListEditor2.Strings.LoadFromStream(m);
  m.Clear;
  LoadUc(dat_name,'path.dat',m);
  p.LoadFromStream(m);
  m.Clear;
  m.Free;
  for i:=0 to p.Count-1 do
  begin
    z:= Tokenize(p[i],'|');
    NodeData:= new (PNodeOptions);
    NodeData.ExtFlag:=z[0];
    NodeData.Path:=z[1];
    TreeView1.Items[i].Data:=NodeData;
  end;
  p.Free;
  z.Free;
  prjini:=TInifile.Create(OpenDialog1.FileName);
  Edit2.Text:=prjini.ReadString('main','custom_name', '');
  Edit3.Text:=prjini.ReadString('main','news_url', '');
  CheckBox1.Checked:=prjini.ReadBool('main','create_st', true);
  Edit4.Text:=prjini.ReadString('main','st_name', '');
  Edit7.Text:=prjini.ReadString('main','app_path', '');
  ComboBox1.Text:=prjini.ReadString('main','skn_name', '');
  Edit5.Text:=prjini.ReadString('build','client_out', '');
  Edit6.Text:=prjini.ReadString('build','updates_out', '');
  prjini.Free;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  PThread : WorkThread;
  Rev, i, TempInt : integer;
  Temp, Temp2, Temp3, Temp4: TStrings;
begin
  if (Edit5.Text='') and (Edit6.Text='') then exit;
  ProgressBar1.Position:=0;
  ProgressBar2.Position:=0;
  Temp:=TstringList.Create;
  Temp2:=TstringList.Create;
  Temp3:=TstringList.Create;
  Temp4:=TstringList.Create;
  Rev:=Round((Now() - 25569.0) * 86400);
  PThread := WorkThread.Create(True);
  PThread.FreeOnTerminate:=True;
  PThread.OutputDir:= Edit6.Text;
  PThread.UpdaterClienName:=Edit2.Text;
  PThread.HostsLines:=ValueListEditor1.Strings;
  For i:=1 to TreeView1.Items.Count-1 do
  begin
    if PNodeOptions(TreeView1.Items[i].Data).ExtFlag = 'root_crit' then break;
    if PNodeOptions(TreeView1.Items[i].Data).ExtFlag = 'file' then
    begin
      Temp.Add(PNodeOptions(TreeView1.Items[i].Data).Path);
      Path:='';
      GetRelativePath(TreeView1.Items[i]);
      Temp2.Add(Path);
    end;
  end;
  TempInt:=i+1;
  PThread.RelativePathsNormal:=Temp2;
  PThread.NormalFiles:=Temp;
  PThread.RevisionNum:=Rev;
  For i:=TempInt to TreeView1.Items.Count-1 do
  begin
    if PNodeOptions(TreeView1.Items[i].Data).ExtFlag = 'file' then
    begin
      Temp3.Add(PNodeOptions(TreeView1.Items[i].Data).Path);
      Path:='';
      GetRelativePath(TreeView1.Items[i]);
      Temp4.Add(Path);
    end;
  end;
  PThread.RelativePathsCritical:=Temp4;
  PThread.CriticalFiles:=Temp3;
  PThread.ClientSrcDir:=ExtractFilePath(Application.ExeName)+'\updater\Updater.exe';
  if (CheckBox1.Checked=True) Then
    PThread.ModHosts:=1;
  Form1.Enabled:=False;
  ProgressBar2.Max:=Temp.Count+Temp3.Count;
  PThread.ClientCustomName:=Edit2.Text;
  if (Checkbox2.Checked) then
    PThread.ClientLinkName:=Edit4.Text;
  PThread.ClientAppExeName:=Edit7.Text;
  PThread.ClientNewsUrl:=Edit3.Text;
  PThread.UpdaterSkinName:=SknPath+ComboBox1.Text;
  PThread.UpdatesMirrorList:=ValueListEditor2.Strings;
  PThread.ClientDestDir:=Edit5.Text;
  PThread.Resume;
end;

procedure TForm1.SaveProject1Click(Sender: TObject);
begin
 if (CurrentPrjName<>'') then SaveProject(CurrentPrjName)
 else SaveProjectAs1Click(nil);
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
 if CheckBox2.Checked then
  Edit4.Enabled:=True
 else
  Edit4.Enabled:=False;
end;

procedure TForm1.NewProject1Click(Sender: TObject);
var
  NodeData: PNodeOptions;
begin
  TreeView1.Items.Clear;
  TreeView1.Items.AddChild(nil,'main files');
  TreeView1.Items.AddChild(nil,'critical files');
  CurrentPrjName:='';
  NodeData:= new (PNodeOptions);
  NodeData.ExtFlag:='root_main';
  NodeData.Path:='none';
  TreeView1.Items[0].Data:=NodeData;
  NodeData:= new (PNodeOptions);
  NodeData.ExtFlag:='root_crit';
  NodeData.Path:='none';
  TreeView1.Items[1].Data:=NodeData;
  Edit2.Text:='';
  Edit3.Text:='';
  Edit4.Text:='';
  Edit5.Text:='';
  Edit6.Text:='';
  Edit7.Text:='';
  ValueListEditor2.Strings.Clear;
  ValueListEditor1.Strings.Clear;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  Path:='';
  GetRelativePath(TreeView1.Selected);
  ShowMessage(Path);

end;

procedure TForm1.Button1Click(Sender: TObject);
var temp: string;
begin
  SelectDirectory('Select Client Out Dir','',temp);
  Edit5.Text:=temp;
  Edit5.Hint:=temp;
end;

procedure TForm1.Button2Click(Sender: TObject);
var temp: string;
begin
  SelectDirectory('Select Updates Out Dir','',temp);
  Edit6.Text:=temp;
  Edit6.Hint:=temp;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var m: TMemoryStream;
begin
  if(ComboBox1.Text<>'') then
    If (FileExists(SknPath+ChangeFileExt(ComboBox1.Text,'.l3i'))) then
     begin
      LoadSki(SknPath+ChangeFileExt(ComboBox1.Text,'.l3i'));
     end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
 m: TMemoryStream;
 StringList: TStringList;
begin
  LoadSkin(SknPath+ComboBox1.Text);
  Form2.Panel1.Visible:=false;
  Form2.Timer1.Enabled:=True;
end;

procedure TForm1.ValueListEditor2DblClick(Sender: TObject);
begin
   ValueListEditor2.InsertRow('','',false);
end;

end.
